//
//  SNUtility.m
//  Luba
//
//  Created by jinlong sheng on 2016/12/15.
//  Copyright © 2016年 sjl. All rights reserved.
//

#import "SNUtility.h"
#import <CommonCrypto/CommonDigest.h>
#import <objc/runtime.h>

#define FileHashDefaultChunkSizeForReadingData 1024*8

@implementation SNUtility
+(UIWindow *)getTopWindow{
    UIWindow * topWindows=[UIApplication sharedApplication].keyWindow;
    for (UIWindow *window in  [UIApplication sharedApplication].windows) {
        if (topWindows==nil) {
            topWindows =window;
        }
        if(topWindows.windowLevel<window.windowLevel){
            topWindows =window;
        }
    }
    return topWindows;
}

+ (NSString*)getUGCimgUploadPath{
    NSFileManager *fileManager = [NSFileManager defaultManager];
    
    NSString *documentsDirectory =NSTemporaryDirectory();
    
    [fileManager createDirectoryAtPath:[documentsDirectory stringByAppendingPathComponent:@"SN_UserPhoto_Upload"] withIntermediateDirectories:YES attributes:nil error:nil];
    
    return [documentsDirectory stringByAppendingPathComponent:@"SN_UserPhoto_Upload"];
}


+(NSString*)getFileMD5WithPath:(NSString*)path
{
    
    return (__bridge_transfer NSString *)FileMD5HashCreateWithPath((__bridge CFStringRef)path, FileHashDefaultChunkSizeForReadingData);
    
}



CFStringRef FileMD5HashCreateWithPath(CFStringRef filePath,size_t chunkSizeForReadingData) {
    
    // Declare needed variables
    
    CFStringRef result = NULL;
    
    CFReadStreamRef readStream = NULL;
    
    // Get the file URL
    
    CFURLRef fileURL =
    
    CFURLCreateWithFileSystemPath(kCFAllocatorDefault,
                                  
                                  (CFStringRef)filePath,
                                  
                                  kCFURLPOSIXPathStyle,
                                  
                                  (Boolean)false);
    
    if (!fileURL) goto done;
    
    // Create and open the read stream
    
    readStream = CFReadStreamCreateWithFile(kCFAllocatorDefault,
                                            
                                            (CFURLRef)fileURL);
    
    if (!readStream) goto done;
    
    bool didSucceed = (bool)CFReadStreamOpen(readStream);
    
    if (!didSucceed) goto done;
    
    // Initialize the hash object
    
    
    CC_MD5_CTX hashObject;
    
    CC_MD5_Init(&hashObject);
    
    // Make sure chunkSizeForReadingData is valid
    
    if (!chunkSizeForReadingData) {
        
        chunkSizeForReadingData = FileHashDefaultChunkSizeForReadingData;
        
    }
    
    // Feed the data to the hash object
    
    bool hasMoreData = true;
    
    while (hasMoreData) {
        
        uint8_t buffer[chunkSizeForReadingData];
        
        CFIndex readBytesCount = CFReadStreamRead(readStream,(UInt8 *)buffer,(CFIndex)sizeof(buffer));
        
        if (readBytesCount == -1) break;
        
        if (readBytesCount == 0) {
            
            hasMoreData = false;
            
            continue;
            
        }
        
        CC_MD5_Update(&hashObject,(const void *)buffer,(CC_LONG)readBytesCount);
        
    }
    
    // Check if the read operation succeeded
    
    didSucceed = !hasMoreData;
    
    // Compute the hash digest
    
    unsigned char digest[CC_MD5_DIGEST_LENGTH];
    
    CC_MD5_Final(digest, &hashObject);
    
    // Abort if the read operation failed
    
    if (!didSucceed) goto done;
    
    // Compute the string result
    
    char hash[2 * sizeof(digest) + 1];
    
    for (size_t i = 0; i < sizeof(digest); ++i) {
        
        snprintf(hash + (2 * i), 3, "%02x", (int)(digest[i]));
        
    }
    
    result = CFStringCreateWithCString(kCFAllocatorDefault,(const char *)hash,kCFStringEncodingUTF8);
    
    
    
done:
    
    if (readStream) {
        
        CFReadStreamClose(readStream);
        
        CFRelease(readStream);
        
    }
    
    if (fileURL) {
        
        CFRelease(fileURL);
        
    }
    
    return result;
    
}
//年月日 时分秒
+ (NSString*)getCurrentTimeStr{
    NSDateFormatter *dateformate=[[NSDateFormatter alloc] init];
    [dateformate setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    NSDate *date =  [NSDate date];
    NSString *reStr=[dateformate stringFromDate:date];
    return reStr;
}
+ (BOOL) imageHasAlpha: (UIImage *) image{
    CGImageAlphaInfo alpha = CGImageGetAlphaInfo(image.CGImage);
    return (alpha == kCGImageAlphaFirst ||
            alpha == kCGImageAlphaLast ||
            alpha == kCGImageAlphaPremultipliedFirst ||
            alpha == kCGImageAlphaPremultipliedLast);
}

+ (NSString*)formatTimeFromSeconds:(int)totalSeconds{
    int seconds = totalSeconds % 60;
    int minutes = (totalSeconds / 60) % 60;
    int hours = totalSeconds / 3600;
    return [NSString stringWithFormat:@"%02d:%02d:%02d", hours, minutes, seconds];
}
//月日 时分
+ (NSString*)formatTimeFromTimeInterval:(double)time{
    
    NSDateFormatter *dateformate=[[NSDateFormatter alloc] init];
    [dateformate setDateFormat:@"MM-dd HH:mm"];
    NSDate *date = [NSDate dateWithTimeIntervalSince1970:time];
    NSString *str = [dateformate stringFromDate:date];
    return str;
    
}



+(BOOL)ApartOneDayMore:(NSString*)key{
    //相隔至少一天
    NSDate *lastDate = [[NSUserDefaults standardUserDefaults] objectForKey:key];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"dd"];
    NSString *lastDayStr = [formatter stringFromDate:lastDate];
    NSString *nowDayStr = [formatter stringFromDate:[NSDate date]];
    //一天有24*24*60秒，大于秒数就是隔天，小于时判断day数，不同也是隔天.返回true
    if ([[NSUserDefaults standardUserDefaults] objectForKey:key]) {
        if (([NSDate date].timeIntervalSince1970-lastDate.timeIntervalSince1970)>24*24*60) {
            [[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:key];
            return true;
        }else if(nowDayStr.intValue!=lastDayStr.intValue){
            [[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:key];
            return true;
        }
        return false;
    }
    //否则,不存在这个字段，说明新装的，返回true
    [[NSUserDefaults standardUserDefaults] setObject:[NSDate date] forKey:key];
    return true;
    
 
}




@end
































